/*
 * "Grundkurs Programmieren in Java (8. Auflage, 2018)"
 * 2003-2018, Carl Hanser Verlag
 * Loesungsvorschlag zu Aufgabe 18.3 (Version 2.0)
 * (c) 2003-2018 D. Ratz, D. Schulmeister-Zimolong, D. Seese, J. Wiesenberger
 *
 */

import javax.swing.*;
import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class ChatFrame extends JFrame implements Runnable {

  public static final String HOST = "localhost";
  public static final int PORT = 7777;

  Container c;
  Socket socket;
  BufferedReader in;
  PrintWriter out;
  JTextField inputField;
  JTextArea outputArea;
  JScrollPane sp;
  String newline = "\n";
  boolean running;

  public static void main(String[] args) {
    ChatFrame frame = new ChatFrame();

    frame.setTitle("Night Chat");
    frame.setSize(800, 600);
    frame.setVisible(true);
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  }

  public ChatFrame() {
    c = getContentPane();
    FeldListener eingabe = new FeldListener();
    inputField = new JTextField();
    inputField.addActionListener(eingabe);
    outputArea = new JTextArea();
    outputArea.setFont( new Font("Courier", Font.PLAIN, 12));
    outputArea.setEditable(false);
    outputArea.setLineWrap(true);
    outputArea.setWrapStyleWord(true);
    sp = new JScrollPane(outputArea);

    c.setLayout(new BorderLayout());
    c.add(inputField, BorderLayout.SOUTH);
    c.add(sp, BorderLayout.CENTER);

    c.setBackground(Color.lightGray);
    c.setForeground(Color.black);
    inputField.setBackground(Color.white);
    outputArea.setBackground(Color.white);

    try {
      socket = new Socket(HOST, PORT);
      in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
      out = new PrintWriter(socket.getOutputStream(),true);

      say("Wer chattet so spaet durch Nacht und Wind?");
      say("Der Vater ist's mit seinem Kind ...");
      say("");
      say("Verbindung zum Server hergestellt!");
      say("Warte auf Partner!");
    } catch (IOException e) {
      say("Verbindung zum Server fehlgeschlagen!");
      System.exit(1);
    }

    running = true;
    new Thread(this).start();
  }

  public void run() {
    String line;

    try {
      while(running) {
        line = in.readLine();

        if(line != null) {
          outputArea.append(line+'\n' );
          outputArea.setCaretPosition(outputArea.getText().length());
        }

        try {
          Thread.sleep(10);
        } catch(InterruptedException e) {
          break;
        }
      }
    } catch (IOException e) {
      say("Verbindung zum Server abgebrochen");
    }
  }

  class FeldListener implements ActionListener {
    public void actionPerformed(ActionEvent evt) {
      String text = inputField.getText();
      outputArea.append("<<< " + text + newline);
      outputArea.setCaretPosition(outputArea.getText().length());
      inputField.selectAll();
      out.println(">>> " + text);
    }
  }

  public void say(String msg) {
    if (!msg.trim().isEmpty()) {
      msg = "*** " + msg + " ***";
    }

    System.out.println(msg);
    outputArea.append(msg + "\n");
  }
}
