/*
 * "Grundkurs Programmieren in Java (8. Auflage, 2018)"
 * 2003-2018, Carl Hanser Verlag
 * Loesungsvorschlag zu Aufgabe 18.2 (Version 2.0)
 * (c) 2003-2018 D. Ratz, D. Schulmeister-Zimolong, D. Seese, J. Wiesenberger
 *
 */

import java.io.*;
import java.net.*;

class EuroServer {
  static boolean serverAktiv = true;

  public static void main(String[] args) {
    // Argumentanzahl ueberpruefen
    if (args.length == 1) {
      // Port-Nummer bestimmen
      int port = Integer.parseInt(args[0]);

      // Try-Catch-Block beginnen
      try {
        // Server-Steuerung aktivieren
        new SteuerDienst().start();

        // Einen Socket fuer den Server erzeugen
        ServerSocket server = new ServerSocket(port);
        System.out.println("Der Server laeuft.");

        // "Endlos"-Schleife
        while (serverAktiv) {
          // Fuer jeden Client, der eine Verbindung aufbaut,
          // einen EuroThread starten
          new EuroThread(server.accept()).start();
        }
      } catch (IOException e) {
        e.printStackTrace();
      }

      System.out.println("Der Server ist beendet.");
    } else {
      // Hinweis fuer korrekten Aufruf auf die Konsole ausgeben
      System.out.println("Aufruf: java EuroServer <PortNummer>");
    }
  }
}
