/*
 * "Grundkurs Programmieren in Java (8. Auflage, 2018)"
 * 2003-2018, Carl Hanser Verlag
 * Loesungsvorschlag zu Aufgabe 18.3 (Version 2.0)
 * (c) 2003-2018 D. Ratz, D. Schulmeister-Zimolong, D. Seese, J. Wiesenberger
 *
 */

import java.io.*;
import java.net.*;

class TalkDienst extends Thread {

  Socket         c1, c2;    // Sockets fuer die beiden Clients
  BufferedReader in;        // Eingabe-Stroeme zu den Clients
  PrintWriter    out;       // Ausgabe-Stroeme zu den Clients

  /**
   * Eingabe- und Ausgabestroeme zu den Clients erzeugen
   *
   */
  TalkDienst(Socket sin, Socket sout) {
    // Die Client-Sockets in den Instanzvariablen speichern
    c1 = sin;
    c2 = sout;
    // try-catch-Block beginnen
    try {
      // Den Eingabe-Strom vom anderen Client erzeugen
      in  = new BufferedReader(new InputStreamReader(c1.getInputStream()));

      // Den Ausgabe-Strom zum anderen Client erzeugen
      out = new PrintWriter(c2.getOutputStream(), true);
      out.println("*** " + "Chatpartner gefunden, es kann losgehen!" + " ***");
    }
    catch (IOException e) { }
  }
  // run-Methode ueberschreiben: Abarbeitung des eigentlichen Protokolls

  public void run() {
    String line;

    try {
      while(true) {
        line=in.readLine();
        if(line!=null)
          out.println(line);
        try {
          Thread.sleep(10);
        }
        catch(InterruptedException e) {
          break;
        }
      }
    }
    catch (IOException e) {
      System.out.println("Fehler:" + e);
    }
  }
}
